from scapy.fields import *

SchemaID = LEShortField("SchemaID",1)
SchemaVersion = LEShortField("SchemaVersion",9)
char   = lambda name: StrFixedLenField(name, b"0",length=1)
int8   = lambda name: SignedByteField(name,0)
uint8  = lambda name: ByteField(name,0)
int16  = lambda name: LESignedShortField(name,0)
uint16 = lambda name: LEShortField(name,0)
int32  = lambda name: LESignedIntField(name,0)
uint32 = lambda name: LEIntField(name,0)
int64  = lambda name: LESignedLongField(name,0)
uint64 = lambda name: LELongField(name,0)
Asset = lambda name : StrFixedLenField(name,default=6*"0",length=6)
CFICode = lambda name : StrFixedLenField(name,default=6*"0",length=6)
CHAR = lambda name : char(name)
Currency = lambda name : StrFixedLenField(name,default=3*"0",length=3)
InstAttribType = lambda name : int8(name)
Int16 = lambda name : int16(name)
Int32 = lambda name : int32(name)
Int32NULL = lambda name : int32(name)
Int8 = lambda name : int8(name)
Int8NULL = lambda name : int8(name)
LocalMktDate = lambda name : uint16(name)
MDEntryTypeChannelReset = lambda name : StrFixedLenField(name,'J',length=1)
MDEntryTypeLimits = lambda name : StrFixedLenField(name,'g',length=1)
MDEntryTypeTrade = lambda name : StrFixedLenField(name,'2',length=1)
MDEntryTypeVol = lambda name : StrFixedLenField(name,'e',length=1)
MDFeedType = lambda name : StrFixedLenField(name,default=3*"0",length=3)
MDUpdateActionNew = lambda name : int8(name)
MDUpdateTypeNew = lambda name : int8(name)
QuoteReqId = lambda name : StrFixedLenField(name,default=23*"0",length=23)
SecurityExchange = lambda name : StrFixedLenField(name,default=4*"0",length=4)
SecurityGroup = lambda name : StrFixedLenField(name,default=6*"0",length=6)
SecurityIDSource = lambda name : StrFixedLenField(name,'8',length=1)
SecuritySubType = lambda name : StrFixedLenField(name,default=5*"0",length=5)
SecurityType = lambda name : StrFixedLenField(name,default=6*"0",length=6)
Symbol = lambda name : StrFixedLenField(name,default=20*"0",length=20)
Text = lambda name : StrFixedLenField(name,default=180*"0",length=180)
UnderlyingSymbol = lambda name : StrFixedLenField(name,default=20*"0",length=20)
UnitOfMeasure = lambda name : StrFixedLenField(name,default=30*"0",length=30)
UserDefinedInstrument = lambda name : StrFixedLenField(name,default=1*"0",length=1)
uInt32 = lambda name : uint32(name)
uInt32NULL = lambda name : uint32(name)
uInt64 = lambda name : uint64(name)
uInt64NULL = lambda name : uint64(name)
uInt8 = lambda name : uint8(name)
uInt8NULL = lambda name : uint8(name)